<?php
/**
 * @version $Id: vmcreditpoints.php, v 2.0
 * @author Marco Coan
 * @package System
 * @copyright Copyright (C) 2012 Marco Coan - All rights reserved.
 * @coding developed in www.virtuemartrewardspoints.com on feb.2012
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
 * http://virtuemart.org
 */
 
 
if( ! defined( '_VALID_MOS' ) && ! defined( '_JEXEC' ) )
	die( 'Direct Access to ' . basename( __FILE__ ) . ' is not allowed.' ) ;
 
 
if (!class_exists('vmPSPlugin')) require(JPATH_VM_PLUGINS . DIRECTORY_SEPARATOR . 'vmpsplugin.php');

class plgVmPaymentCreditpoints extends vmPSPlugin {

	// instance of class
    public static $_this = false;
	
	
    function __construct(& $subject, $config) {
	    // 		vmdebug('Plugin stuff',$subject, $config);
		parent::__construct($subject, $config);
		$this->_loggable = TRUE;
		$this->tableFields = array_keys ($this->getTableSQLFields ());
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		
		$varsToPush = $this->getVarsToPush ();
		
    	$this->setConfigParameterable ($this->_configTableFieldName, $varsToPush);
	}
	
	public function getVmPluginCreateTableSQL () {
		return $this->createTableSQL ('Payment Creditpoints Table');
	}
	
	function getTableSQLFields () {

		$SQLfields = array(
			'id'                          => 'int(1) UNSIGNED NOT NULL AUTO_INCREMENT',
			'virtuemart_order_id'         => 'int(1) UNSIGNED',
			'order_number'                => 'char(64)',
			'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
			'payment_name'                => 'varchar(5000)',
			'payment_order_total'         => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
			'payment_currency'            => 'char(3)',
			'email_currency'              => 'char(3)',
			'cost_per_transaction'        => 'decimal(10,2)',
			'cost_percent_total'          => 'decimal(10,2)',
			'tax_id'                      => 'smallint(1)'
		);

		return $SQLfields;
	}
	

	function plgVmOnConfirmedOrderStorePaymentData($virtuemart_order_id, VirtueMartCart $cart, $priceData) {
        return false;
    }



	function plgVmConfirmedOrder($cart, $order) {		
		
		// VIRTUEMART ------------------------------- 
		if (!($method = $this->getVmPluginMethod ($order['details']['BT']->virtuemart_paymentmethod_id))) return NULL; 
		if (!$this->selectedThisElement ($method->payment_element)) return FALSE;
		VmConfig::loadJLang('com_virtuemart',true);
		VmConfig::loadJLang('com_virtuemart_orders', TRUE);
		if (!class_exists ('VirtueMartModelOrders')) require(VMPATH_ADMIN . DS . 'models' . DS . 'orders.php');
		if (!class_exists('VirtueMartModelCurrency')) require(JPATH_VM_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'currency.php');
		// ------------------------------------------
		
		$lang = JFactory::getLanguage();
		$filename = 'com_virtuemart';
		$lang->load($filename, JPATH_ADMINISTRATOR);
		$this->getPaymentCurrency($method);
		$currency_code_3 = shopFunctions::getCurrencyByID($method->payment_currency, 'currency_code_3');
		//$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		//$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
		$totalInPaymentCurrency = round($order['details']['BT']->order_total,2)." ".$method->credit_currency;

		$modelOrder = VmModel::getModel ('orders');
		$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order['details']['BT']->order_number);
		$credit_ratio = round((float)$method->credit_ratio,3) ;
		$order_total = $order['details']['BT']->order_total * $credit_ratio;
		
		$this->_virtuemart_paymentmethod_id = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['payment_name'] = $this->renderPluginName($method);
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['virtuemart_paymentmethod_id'] = $this->_virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $currency_code_3 ;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		$dbValues['tax_id'] = $method->tax_id;
		$this->storePSPluginInternalData($dbValues);
		
		$html = $this->renderByLayout('post_payment', array(
			'order_number' =>$order['details']['BT']->order_number,
			'order_pass' =>$order['details']['BT']->order_pass,
			'payment_name' => $dbValues['payment_name'],
			'displayTotalInPaymentCurrency' => $totalInPaymentCurrency
		));
		
		$_db = JFactory::getDBO();
		$user = JFactory::getUser();
		// carica virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$referreId = RewardHelper::getAnyUserReferreID($user->id ); // find user in VRP
		$points = RewardHelper::getCurrentTotalPoints($referreId);
		
		if ($order_total <= $points){
			$order['order_status'] = $method->status_success;
			$order['virtuemart_order_id'] = $virtuemart_order_id;
			$order['customer_notified'] = 1;
			$order['comments'] = '';
			// NOTA IL PAGAMENTO CON I PUNTI SEGUIRA' SU HANDLER plgVmOnUpdateOrderPayment
			$modelOrder->updateStatusForOneOrder($order['details']['BT']->virtuemart_order_id, $order, true);
			//delete the old stuff
			$cart->emptyCart ();
			vRequest::setVar ('html', $html);
			return TRUE;
		} else {
			// qui nn ci arriva mai ma per sicurezza
			JError::raiseWarning(500, JText::_('VMPAYMENT_VCP_CANCELED') );
			$modelOrder->remove($order['details']['BT']->virtuemart_order_id);
			return FALSE;
		}
	}
	
	  /*
	  function plgVmOnPaymentResponseReceived( $pelement)  {
		  return null;
	 }
*/
	/**
	 * Display stored payment data for an order
	 * @see components/com_virtuemart/helpers/vmPaymentPlugin::plgVmOnShowOrderPaymentBE()
	 */

	
	 
	
	/**
     * Display stored payment data for an order
     *
     */
    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id) {
		if (!$this->selectedThisByMethodId($virtuemart_payment_id)) {
			return null; // Another method was selected, do nothing
		}
	
		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` '
			. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject())) {
			vmWarn(500, $q . " " . $db->getErrorMsg());
			return '';
		}
		$this->getPaymentCurrency($paymentTable);
	
		$html = '<table class="adminlist">' . "\n";
		$html .=$this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE('VCP_PAYMENT_NAME', $paymentTable->payment_name);
		$html .= $this->getHtmlRowBE('VCP_PAYMENT_TOTAL_CURRENCY', $paymentTable->payment_order_total.' '.$paymentTable->payment_currency);
		$html .= '</table>' . "\n";
		return $html;
		}
	
		function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
		if (preg_match('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }
	
	
	
	
	
	
	
	
	 /**
     * Check if the payment conditions are fulfilled for this payment method
     * @author: Valerie Isaksen
     *
     * @param $cart_prices: cart prices
     * @param $payment
     * @return true: if the conditions are fulfilled, false otherwise
     *
     */
     protected function checkConditions($cart, $method, $cart_prices) {    	
		
    	// -----------------------------------------------------------------------------
    	// -----------------------------------------------------------------------------
    	// -----------------------------------------------------------------------------
    	// per Virtuemart  	
    	$this->convert_condition_amount($method);
		$amount = $this->getCartAmount($cart_prices);
		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0)));
		if (!$amount_cond) {
			return FALSE;
		}
		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array ($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
		if (!is_array ($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}
		if (!isset($address['virtuemart_country_id'])) {
			$address['virtuemart_country_id'] = 0;
		}
		$api_VRP = JPATH_SITE. DIRECTORY_SEPARATOR .'components'. DIRECTORY_SEPARATOR .'com_rewardpointsvm'. DIRECTORY_SEPARATOR .'helper.php';
		if (! file_exists($api_VRP)) {
			JError::raiseWarning(500, JText::_('VMPAYMENT_VCP_VRPMUSTBE') );
			return false;
		}
		// -----------------------------------------------------------------------------
		// -----------------------------------------------------------------------------
		// -----------------------------------------------------------------------------
		
	  	// credit points - cerca le combinazioni di prodotti presenti nel carrello
	  	// eventualmente svuota o l'una o l'altra

		$app = JFactory::getApplication();
	 	$user = JFactory::getUser();
	 	$userid = $user->id;
		$db = JFactory::getDBO();
		
		
		// controllo che provenga richiesta restorecart da eventuale modulo
		/*
$session = JFactory::getSession();
		//$restoreCart = false;
		if($session->get('creditpoints_savecart_restoring') ) {
			$session->clear('creditpoints_savecart_restoring');
			$app->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart',false));
			return false;
			//$restoreCart = true;
			//plgVmPaymentCreditpoints::restoreCart();
			//return false;
		}
*/
		
		
		$q = "SELECT * FROM #__virtuemart_paymentmethods WHERE payment_element='creditpoints' ";
		$db->setQuery($q);
		$paymentmethod = $db->loadAssoc();


		if($cart->products){ // solo se il carrello contiene qualcosa
			if (!class_exists('VirtueMartCart')) require(JPATH_VM_SITE . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'cart.php');
			// carica virtuemart reward points --------------------------------
			$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
			require_once ($api_VRP);
			$config = RewardHelper::getSettings();
			
			$myCart = VirtueMartCart::getCart(false);
			
			$foundCreditFlag = false;
			$foundRegularFlag = false;
			$targetCreditToRemove = array();
			$targetRegularToRemove = array();
			$saveCart = false;
			$firstProductFound = false;
			$reloadCartWithCredit = false;
			$reloadCartWithRegular = false;
							
			// ----------------------------------------------------------------------
			// controlla quale e' id del creditpoints customfield
			// ----------------------------------------------------------------------
			$db = JFactory::getDBO();
			$q = "SELECT virtuemart_custom_id FROM #__virtuemart_customs WHERE "; // trova il custom field creditpoints ::VM2.x
			$q .= "custom_element='vmcreditpoints' ";
			$db->setQuery($q);
			$creditPointsFieldId = $db->loadResult();
			
			// ----------------------------------------------------------------------
			// test carrello
			// ----------------------------------------------------------------------
			foreach($cart->products as $product){
				if($creditPointsFieldId) {
					// controlla se il prodotto ha dei credit point ed esegue acquisto punti
					$q = "SELECT customfield_value FROM #__virtuemart_product_customfields WHERE ";
					$q .= "virtuemart_product_id=".$product->virtuemart_product_id." AND ";
					$q .= "virtuemart_custom_id=".$creditPointsFieldId." ";
					$db->setQuery($q);
					$creditProductId = $db->loadResult();
					if ($creditProductId) {
						$foundCreditFlag = true; // TROVATO CREDIT nel carrello
						array_push($targetCreditToRemove, $product->cart_item_id);
						if(!$firstProductFound) $firstProductFound = "credit";
					} else {
						$foundRegularFlag = true; // TROVATO REGULAR nel carrello
						array_push($targetRegularToRemove, $product->cart_item_id);
						if(!$firstProductFound) $firstProductFound = "regular";
					}
				}
			}
			
			$redirect = false;
			$returnMethod = true;
			if($firstProductFound == "credit"){
				if($foundRegularFlag && $foundCreditFlag){ // solo se con carrello misto, esegui eliminazione e backup
					// elimina prodotto CREDIT dal carrello	
					// ----------------------------------------	
					foreach($targetCreditToRemove as $remove){
						$myCart->removeProductCart($remove);
						//JError::raiseWarning(500, "rimuovo creditproduct");
					}
					$redirect = true;
				}
				// --------------------------------------------
			 	// TOGLIE IN AUTOMATICO CREDITPOINT SE E' SETTATO
			 	// --------------------------------------------
				if($cart->virtuemart_paymentmethod_id == $paymentmethod['virtuemart_paymentmethod_id']){
					$cart->setPaymentMethod(true,false,0);
					$returnMethod = false;
					$redirect = true; // ricalcola carrello
					if(!$config['credit_system_hide_credit']) $config['credit_system_hide_credit'] = "show";
					if($config['credit_system_hide_credit'] == "show"){
						$app->enqueueMessage(JText::_('VMPAYMENT_VCP_CHOSE_REGULAR_PAYMENT'), 'Message' );
						$redirect = false;
						$returnMethod = false;
					}
				}
				if($redirect) $app->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart',false));
				return $returnMethod;
			}
			if($firstProductFound == "regular"){
				if($foundRegularFlag && $foundCreditFlag){ // solo se con carrello misto, esegui eliminazione e backup
					// SALVA IL CARRELLO
					// ----------------------------------------------------------------------
					$session = JFactory::getSession();
					//if(!$session->get('creditpoints_savecart')) { 
						$currentUser = JFactory::getUser();
												
						if(!$currentUser->guest){
							// salva carrello
							$myCart->storeCart();
							// legge dal db appena salvato
							$q = "SELECT * FROM #__virtuemart_carts WHERE ";
							$q .= "virtuemart_user_id=".$currentUser->id." ORDER BY `modified_on` DESC ";
							$db->setQuery($q);
							$savedCartDataDB = $db->loadObject();
							//JError::raiseWarning(500, print_r($savedCartDataDB,true) );
							// cancella dal db rewardpoints_savecart le linee dell'utente...
							$q = "DELETE FROM #__virtuemart_rewardspoints_savecarts WHERE ";
							$q .= "virtuemart_user_id=".$currentUser->id;
							$db->setQuery($q);
							$result = $db->execute();
							// ...e aggiorna con il nuovo carrello autosave
							$q = "INSERT INTO #__virtuemart_rewardspoints_savecarts (`virtuemart_cart_id`, `virtuemart_user_id`, `virtuemart_vendor_id`, `cartData`, `modified_on`, `modified_by`) VALUES ";
							$q .= "(".$savedCartDataDB->virtuemart_cart_id.", ".$savedCartDataDB->virtuemart_user_id.", ".$savedCartDataDB->virtuemart_vendor_id.", '".$savedCartDataDB->cartData."', '".$savedCartDataDB->modified_on."', '".$savedCartDataDB->modified_by."');";
							$db->setQuery($q);
							$result = $db->execute();
							$session->set('creditpoints_savecart', true); // serve al modulo per accendere il pulsante
							// avvisa avvenuto salvataggio
							$app->enqueueMessage(JText::_('VMPAYMENT_VCP_CARTSAVED'), 'Message' );
							$redirect = true;
						} else {
							// per user guest
							if(!$cartDataToStore) $cartDataToStore = json_encode($myCart->getCartDataToStore());
							//JError::raiseWarning(500, print_r($cartDataToStore,true) );
							$session->set('creditpoints_savecart', $cartDataToStore); // salva il $cartDataToStore in variabile x l'utente guest.
							// avvisa avvenuto salvataggio
							$app->enqueueMessage(JText::_('VMPAYMENT_VCP_CARTSAVED'), 'Message' );
							$redirect = true;
						}
	
					//}
					
					// elimina prodotto REGULAR dal carrello
					// ----------------------------------------	
					//JError::raiseWarning(500, "rimuovo regolari");
					foreach($targetRegularToRemove as $remove){
						$myCart->removeProductCart($remove);
					}						
					
			 	}
			 	// --------------------------------------------
			 	// SETTA IN AUTOMATICO CREDITPOINT SE NON E' SETTATO
			 	// --------------------------------------------
				if($cart->virtuemart_paymentmethod_id != $paymentmethod['virtuemart_paymentmethod_id']){
				 	if(!$config['credit_system_hide_other']) $config['credit_system_hide_other'] = "show";
				 	if($config['credit_system_hide_other'] == "hide"){
				 		$cart->setPaymentMethod(true,true,$paymentmethod['virtuemart_paymentmethod_id']);
				 		//$redirect = true; // redirect gia' settato nel metodo
				 		$returnMethod = true;
				 	}
			 	}
				if($redirect) $app->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart',false));
				return $returnMethod;
			}
		}
		
		if (count ($countries) == 0 || in_array ($address['virtuemart_country_id'], $countries) ) {
			return TRUE;
		}			
		return FALSE;
		
    }
    
	
	
	
	
	
	
	
	/*
     * We must reimplement this triggers for joomla 1.7
     */

    /**
     * Create the table for this plugin if it does not yet exist.
     * This functions checks if the called plugin is active one.
     * When yes it is calling the standard method to create the tables
     * @author Valrie Isaksen
     *
     */
    function plgVmOnStoreInstallPaymentPluginTable ($jplugin_id) {
		return $this->onStoreInstallPluginTable ($jplugin_id);
	}

    /**
     * This event is fired after the payment method has been selected. It can be used to store
     * additional payment info in the cart.
     *
     * @author Max Milbers
     * @author Valrie isaksen
     *
     * @param VirtueMartCart $cart: the actual cart
     * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
     *
     */
    public function plgVmOnSelectCheckPayment (VirtueMartCart $cart, &$msg) {				
		return $this->OnSelectCheck ($cart);
		
	}

	protected function renderPluginName($activeMethod) {
		$return = '';
		$plugin_name = $this->_psType . '_name';
		$plugin_desc = $this->_psType . '_desc';
		$description = '';
		// 		$params = new JParameter($plugin->$plugin_params);
		// 		$logo = $params->get($this->_psType . '_logos');
		$logosFieldName = $this->_psType . '_logos';
		$logos = $activeMethod->$logosFieldName;
		if (!empty($logos)) {
			$return = $this->displayLogos($logos) . ' ';
		}
		$pluginName = $return . '<span class="' . $this->_type . '_name">' . $activeMethod->$plugin_name . '</span>';
		if (!empty($activeMethod->$plugin_desc)) {
			$pluginName .= '<span class="' . $this->_type . '_description">' . $activeMethod->$plugin_desc . '</span>';
		}
		return $pluginName;
	}


	
    /**
     * plgVmDisplayListFEPayment
     * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
     *
     * @param object $cart Cart object
     * @param integer $selected ID of the method selected
     * @return boolean True on succes, false on failures, null when this plugin was not selected.
     * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
     *
     * @author Valerie Isaksen
     * @author Max Milbers
     */
    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		
		// carica virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings(); 
		// -------------------------------------------------------------------------
		
		// trova il custom field creditpoints ::VM2.x
		$db = JFactory::getDBO();
		$q = "SELECT virtuemart_custom_id FROM #__virtuemart_customs WHERE ";
		$q .= "custom_element='vmcreditpoints' ";
		$db->setQuery($q);
		$creditPointsFieldId = $db->loadResult();
		if($creditPointsFieldId) {
			// controlla se i prodotti in carrello contengono prodotti credits e solo prodotti credits
			$creditPointsProductCount = 0;
			foreach ($cart->products as $item){
				// controlla se c'e' un prodotto che ha acquisto punti credito
				$q = "SELECT `virtuemart_customfield_id` FROM #__virtuemart_product_customfields WHERE ";
				$q .= "virtuemart_product_id=".$item->virtuemart_product_id." AND ";
				$q .= "virtuemart_custom_id='".$creditPointsFieldId."' ";
				$db->setQuery($q);
				$creditPoints = $db->loadResult();
				if($creditPoints)	$creditPointsProductCount ++;
			}
			
			// check se in configurazione non esistono valori settati
			if(!isset($config['credit_system_hide_credit'])) $config['credit_system_hide_credit'] = "show";
			if(!isset($config['credit_system_hide_other'])) $config['credit_system_hide_other'] = "show";
			
			if($creditPointsProductCount > 0) { // se sono stati trovati punti credito				
				if($creditPointsProductCount == count($cart->products)){
					if($config['credit_system_hide_credit'] == 'hide'){
						return null;
					}
				} else {
					if($config['credit_system_hide_other'] == 'hide'){
						$htmlIn = ""; // cancella tutti gli altri sistemi di pagamento disponibili	
					}
				}
			} else {
				if($config['credit_system_hide_other'] == 'hide'){
					$htmlIn = ""; // cancella tutti gli altri sistemi di pagamento disponibili	
				}
			}
		}		 
		return $this->displayListFE($cart, $selected, $htmlIn);
    }

    /*
     * plgVmonSelectedCalculatePricePayment
     * Calculate the price (value, tax_id) of the selected method
     * It is called by the calculator
     * This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
     * @author Valerie Isaksen
     * @cart: VirtueMartCart the current cart
     * @cart_prices: array the new cart prices
     * @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
     *
     *
     */

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			 return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			 return false;
		}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
   }

    /**
     * plgVmOnCheckAutomaticSelectedPayment
     * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
     * The plugin must check first if it is the correct type
     * @author Valerie Isaksen
     * @param VirtueMartCart cart: the cart object
     * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
     *
     */
    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    /**
     * This method is fired when showing the order details in the frontend.
     * It displays the method-specific data.
     *
     * @param integer $order_id The order ID
     * @return mixed Null for methods that aren't active, text (HTML) otherwise
     * @author Max Milbers
     * @author Valerie Isaksen
     */
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
	$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    /**
     * This event is fired during the checkout process. It can be used to validate the
     * method data as entered by the user.
     *
     * @return boolean True when the data was valid, false otherwise. If the plugin is not activated, it should return null.
     * @author Max Milbers*/

     public function plgVmOnCheckoutCheckDataPayment(  VirtueMartCart $cart) {	 	
	 	
	 	$app = JFactory::getApplication();
	 	$user = JFactory::getUser();
	 	$userid = $user->id;
		$db = JFactory::getDBO();
		
		if (!class_exists('VirtueMartCart')) require(JPATH_VM_SITE . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'cart.php');
		// carica virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$config = RewardHelper::getSettings();
				
		// controlli se NON e' settato attualmente il creditpoint e se si acquistano regular product
	 	$q = "SELECT * FROM #__virtuemart_paymentmethods WHERE payment_element='creditpoints' ";
		$db->setQuery($q);
		$paymentmethod = $db->loadAssoc();
	 	
	 	// in caso NON sia payment creditpoint, check auto-enable (se si comprano prodotti regular) se no abort resto funzione
	 	if($cart->virtuemart_paymentmethod_id != $paymentmethod['virtuemart_paymentmethod_id']){
	        return; 
	 	}
	 	
	 	// controlla tipologia prodotti che contiene il carrello
		$q = "SELECT virtuemart_custom_id FROM #__virtuemart_customs WHERE ";
		$q .= "custom_element='vmcreditpoints' ";
		$db->setQuery($q);
		$creditPointsFieldId = $db->loadResult();
		if($creditPointsFieldId) {
			// controlla se i prodotti in carrello contengono prodotti credits e solo prodotti credits
			foreach ($cart->products as $item){
				// controlla se c'e' un prodotto che ha acquisto punti credito
				$q = "SELECT `virtuemart_customfield_id` FROM #__virtuemart_product_customfields WHERE ";
				$q .= "virtuemart_product_id=".$item->virtuemart_product_id." AND ";
				$q .= "virtuemart_custom_id='".$creditPointsFieldId."' ";
				$db->setQuery($q);
				$creditPoints = $db->loadResult(); 
				if($creditPoints) {	// SE ESISTE CI SONO PRODOTTI CREDIT NEL CARRELLO
					return;
				}
			}
		}	
		
		// controlli se NON e' settato attualmente il creditpoint e se si acquistano regular product
	 	$q = "SELECT * FROM #__virtuemart_paymentmethods WHERE payment_element='creditpoints' ";
		$db->setQuery($q);
		$paymentmethod = $db->loadAssoc();
	
			 	
	 	// carica i prezzi del carrello
	 	$prices = $cart->getCartPrices();
	 	$prices = (object)$prices;
	 	$order_total =  $prices->billTotal;
		if($order_total==0) return;
			
	 	// carica i settaggi di creditpoints
	 	$payparams = array();
	 	$params = explode("|", $paymentmethod['payment_params']);
	 	foreach ($params as $param) {
		 	$parameter = explode("=", $param);
		 	$replace = array('', '', '"');
		 	if(!isset($parameter[1])) $parameter[1] = null;
		 	$parameter[1] = str_replace($replace, "", $parameter[1]);
		 	$payparams[$parameter[0]] = $parameter[1];
		}
		$method = (object)$payparams;
		$credit_ratio = round((float)$method->credit_ratio,3) ;
		if (!empty($credit_ratio)) $order_total = $order_total * $credit_ratio;
		if(!$order_total) return;
		   
		if(!$user->guest){
			$referreId = RewardHelper::getAnyUserReferreID($userid ); // find user in VRP
			$points = RewardHelper::getCurrentTotalPoints($referreId);
			
			if ($points < $order_total){
				if($config['credit_purchasing_menuid']){
					 // redirect a pagina di acquisto crediti se specificata
					 $menu = $app->getMenu();
					 $item = $menu->getItem( $config['credit_purchasing_menuid'] );
					 $app->enqueueMessage(JText::_('VMPAYMENT_VCP_NOTENOUGH'), 'Message' );
					 $app->redirect(JRoute::_($item->link,false));
					 return false;
				}
				// senza redirect
				$app->enqueueMessage(JText::_('VMPAYMENT_VCP_NOTENOUGH'), 'Message' );
				return false;
			}
		}
	     
    return null;
    }
     

    /**
     * This method is fired when showing when priting an Order
     * It displays the the payment method-specific data.
     *
     * @param integer $_virtuemart_order_id The order ID
     * @param integer $method_id  method used for this order
     * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
     * @author Valerie Isaksen
     */
    function plgVmonShowOrderPrintPayment ($order_number, $method_id) {

		return $this->onShowOrderPrint ($order_number, $method_id);
	}

	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}
	function plgVmSetOnTablePluginParamsPayment ($name, $id, &$table) {

		return $this->setOnTablePluginParams ($name, $id, $table);
	}

    //Notice: We only need to add the events, which should work for the specific plugin, when an event is doing nothing, it should not be added

    
    
    public function plgVmOnUpdateOrderPayment(  $data, $oldStatus) {
	      
	    // avviene in caso fosse selezionato order status P quando si paga con i punti
	 	// in quel caso bisogna aspettare a sottrarre i punti finche' l'ordine non e' C o U
	 	
	 	//JError::raiseWarning(500, print_r($data,true));
 	
	 	// controlla se il metodo di pagamento selezionato era punti
	 	// trova ordine
	 	$app = JFactory::getApplication();
	 	$db = JFactory::getDBO();
	 	$q = "SELECT * FROM #__virtuemart_paymentmethods WHERE payment_element='creditpoints' ";
		$db->setQuery($q);
		$paymentmethod = $db->loadAssoc();
		// abort in caso non sia pagamento in punti
	 	if($data->virtuemart_paymentmethod_id != $paymentmethod['virtuemart_paymentmethod_id']){
	         // JError::raiseWarning(500, "metodo di pagamento NON in punti");
	         return null; 
	 	}	 	
	 	
	 	
	 	// carica i settaggi di creditpoints
	 	$payparams = array();
	 	$params = explode("|", $paymentmethod['payment_params']);
	 	foreach ($params as $param) {
		 	$parameter = explode("=", $param);
		 	$replace = array('', '', '"');
		 	if(!isset($parameter[1])) $parameter[1] = null;
		 	$parameter[1] = str_replace($replace, "", $parameter[1]);
		 	$payparams[$parameter[0]] = $parameter[1];
		}
		$method = (object)$payparams;
		//JError::raiseWarning(500, "metodo ".print_r($method,true));
		
		// prosegue se e' settato un credit_ratio
		$credit_ratio = round((float)$method->credit_ratio,3) ;
		if (!empty($credit_ratio) ){
			$order_total =  $data->order_total;
			$order_total = $order_total * $credit_ratio;
		}
			
		// carica virtuemart reward points --------------------------------
		$api_VRP = JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_rewardpointsvm'.DIRECTORY_SEPARATOR.'helper.php';
		require_once ($api_VRP);
		$referreId = RewardHelper::getAnyUserReferreID($data->virtuemart_user_id ); // find user in VRP
		$points = RewardHelper::getCurrentTotalPoints($referreId);
		
		
		$newStatus = $data->order_status;
		
		// CASO 1 - ritorna i punti in caso di cancellazione o di ritorno a P da C,U,S
		if( ($newStatus == "P" && $oldStatus != "X" && $oldStatus != "R" && $oldStatus != "") || ($newStatus == "R" && $oldStatus != "X" && $oldStatus != "P" && $oldStatus != "") || ($newStatus == "X" && $oldStatus != "R" && $oldStatus != "P" && $oldStatus != "") ) {
			
			RewardHelper::newPoints( 'plgaup_vmcreditpoints', $referreId,  $data->order_number, JText::_('VMPAYMENT_VCP_RESTORE_ORDERNUMBER').': '. $data->order_number, $order_total); // order_total valore positivo
			$app = JFactory::getApplication();
			if ($app->isAdmin()) {
				JError::raiseNotice(100, $order_total." ".JText::_('VMPAYMENT_VCP_REFUNDED_BACKEND')." ".$data->virtuemart_user_id);
			} // non esiste un frontend per il refund o re-pending

			// CONTROLLA SE RIGUARDAVA ACQUISTO DI CREDITI, NEL QUAL CASO CANCELLALI (difficile che avvenga acquisto crediti con i crediti)
			// carica linea db ordine virtuemart
			$q = "SELECT * FROM #__virtuemart_order_items, #__virtuemart_products, #__virtuemart_product_customfields, #__virtuemart_customs WHERE ";
			$q .= "#__virtuemart_order_items.virtuemart_order_id='".$data->virtuemart_order_id."' AND ";
			$q .= "#__virtuemart_products.product_sku = #__virtuemart_order_items.order_item_sku AND ";
			$q .= "#__virtuemart_product_customfields.virtuemart_product_id = #__virtuemart_products.virtuemart_product_id AND ";
			$q .= "#__virtuemart_customs.custom_element='vmcreditpoints' AND ";
			$q .= "#__virtuemart_product_customfields.virtuemart_custom_id = #__virtuemart_customs.virtuemart_custom_id ;";
			$db->setQuery($q);
			$orderitems = $db->loadAssocList();
			$totalCreditToDelete = 0;
			foreach($orderitems as $orderitem){
				if($orderitem['custom_element'] == 'vmcreditpoints' ){ //il prodotto usa il product custom field creditpoints
					$totalCreditToDelete += floatval($orderitem['customfield_value']*$orderitem['product_quantity']);
					// esegue lo storno dei crediti acquistati
				}				
			}
			if($totalCreditToDelete>0){
				RewardHelper::newPoints( 'plgaup_vmcreditpoints', $referreId,  $data->order_number, JText::_('VMPAYMENT_VCP_RESTORE_CANCEL_CREDITS').': '. $data->order_number, -$totalCreditToDelete); // order_total valore positivo
				if ($app->isAdmin()) JError::raiseNotice(100, $totalCreditToDelete." purchased credit deleted for order ".$data->order_number." to user ".$data->virtuemart_user_id);
			}
			return null;
		}
		
		// CASO 2 - in caso di P NUOVO ORDINE (poiche' questo caso deve forzatamente essere scelto nel credipoints plugin setting)
		// fai nulla e avvisa utente (solo frontend). Se derivante da scalatura C - U - S rifonde subito al passo 1
		if ($newStatus == "P" && $oldStatus != "C" && $oldStatus != "U" && $oldStatus != "S") {
			if ($app->isAdmin()) {
				//JError::raiseWarning(500, $order_total." ".JText::_('VMPAYMENT_VCP_PENDING')." ".$data->virtuemart_user_id);
			} else {
				$app->enqueueMessage($order_total." ".JText::_('VMPAYMENT_VCP_SUCCESS_BACKEND'), 'Message');
			}
			return null;
		}
		
		
		// CASO 3 - paga con i punti in caso di status C - U - S (ordine nuovo (e non da P) e ordine confermato da refusioni)
		if( ($newStatus == "C" && $oldStatus != "U" && $oldStatus != "S") || ($newStatus == "U" && $oldStatus != "C" && $oldStatus != "S") || ($newStatus == "S" && $oldStatus != "C" && $oldStatus != "U")   ) {
			RewardHelper::newPoints( 'plgaup_vmcreditpoints', $referreId,  $data->order_number, JText::_('VMPAYMENT_VCP_ORDERNUMBER').': '. $data->order_number, -$order_total);  // order_total valore negativo
			$app = JFactory::getApplication();
			if ($app->isAdmin()) {
				JError::raiseNotice(100, $order_total." ".JText::_('VMPAYMENT_VCP_SUCCESS_BACKEND')." ".$data->virtuemart_user_id);
			} else {
				$app->enqueueMessage($order_total." ".JText::_('VMPAYMENT_VCP_SUCCESS_FRONTEND'), 'Message');
			}
			return null;
		}
	 	return null;
    }


	  
     /**
     * Save updated orderline data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk
     *
      public function plgVmOnUpdateOrderLine(  $_formData) {
      return null;
      }

      /**
     * plgVmOnEditOrderLineBE
     * This method is fired when editing the order line details in the backend.
     * It can be used to add line specific package codes
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk
     *
      public function plgVmOnEditOrderLineBEPayment(  $_orderId, $_lineId) {
      return null;
      }

      /**
     * This method is fired when showing the order details in the frontend, for every orderline.
     * It can be used to display line specific package codes, e.g. with a link to external tracking and
     * tracing systems
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk
     *
      public function plgVmOnShowOrderLineFE(  $_orderId, $_lineId) {
      return null;
      }

      /**
     * This event is fired when the  method notifies you when an event occurs that affects the order.
     * Typically,  the events  represents for payment authorizations, Fraud Management Filter actions and other actions,
     * such as refunds, disputes, and chargebacks.
     *
     * NOTE for Plugin developers:
     *  If the plugin is NOT actually executed (not the selected payment method), this method must return NULL
     *
     * @param $return_context: it was given and sent in the payment form. The notification should return it back.
     * Used to know which cart should be emptied, in case it is still in the session.
     * @param int $virtuemart_order_id : payment  order id
     * @param char $new_status : new_status for this order id.
     * @return mixed Null when this method was not selected, otherwise the true or false
     *
     * @author Valerie Isaksen
     *
     *
      public function plgVmOnPaymentNotification() {
      return null;
      }

      /**
     * plgVmOnPaymentResponseReceived
     * This event is fired when the  method returns to the shop after the transaction
     *
     *  the method itself should send in the URL the parameters needed
     * NOTE for Plugin developers:
     *  If the plugin is NOT actually executed (not the selected payment method), this method must return NULL
     *
     * @param int $virtuemart_order_id : should return the virtuemart_order_id
     * @param text $html: the html to display
     * @return mixed Null when this method was not selected, otherwise the true or false
     *
     * @author Valerie Isaksen
     *
     *
      function plgVmOnPaymentResponseReceived(, &$virtuemart_order_id, &$html) {
      return null;
      }
     */

 
}

// No closing tag